#include "metals.inc"
#include "stdinc.inc"
/********************************************==#include "colors.inc"
                                               #include "shapes.inc"
                                               #include "transforms.inc"
                                               #include "consts.inc"
                                               #include "functions.inc"
                                               #include "math.inc"
                                               #include "rand.inc"*/
#include "echo.inc"
#include "shapes2.inc"
#declare n_Sea = normal
{  function { f_ridged_mf (x, y, z, 0.1, 3.0, 7, 0.7, 0.7, 2) } 2
}
#declare _stereo_ = 0;   //makes L/R frames
// composite -depth 8 -stereo heart03R.png heart03L.png heart03_3d.png

#declare FT = <0,0,0,.6,.38>;
#declare CAUSTICSfile = 0;   // -1,0,1   -1 to reuse
#declare SCATT = 0;
#declare NORMALS = 1;
#declare DOF = 1.0;          /* depth of field camera blur */
#declare REFLECTIONS = 1;
#declare REFRACTION = 1.55;
#declare MEDIA = 0;
#declare HQ = 0;
#declare _mblur = 0;

#if (HQ)
   #declare Puddle = 10;    // 12  hrs everything
   #declare CubeDraw = 10;  // 8.5 hrs no puddle
   #declare FocalBlur = 10; // 1.5 hrs w/ no AL no Photons - all objs?
   
   #declare AreaLite = 10;  // 8 minutes no FB no Photons
   #declare Photons = 10;   // 8.5 minutes w/ cube only
   #declare Cat = 10;
   #declare Noose = 10;
   #declare Book = 10;
   #declare L2 = 0;
#else
   #declare Puddle = 0;
   #declare CubeDraw = 0;// 6 minutes
   #declare Photons = 0;  // 19.5 minutes  w/ cube and puddle only
   #declare FocalBlur = 0;

   #declare AreaLite = 0;
   #declare Cat = 0;
   #declare Noose = 0;
   #declare Book = 0;
   #declare L2 = 0;
#end

global_settings {

#if (_mblur) motion_blur 4, .1 #end
   assumed_gamma 1.0
   max_trace_level 10
   adc_bailout 1/64
     #if (Photons) photons {
     
#if (CAUSTICSfile > 0)
save_file "caustic.phm"
#else
#if (CAUSTICSfile = -1) load_file "caustic.phm"
#end #end	
		
     spacing 0.02   
     count 20000                 // help example 20000
     max_trace_level 10 
     autostop 0
    }  #end
}

              
light_source {
< -6, 7,-5>
rgb .7
spotlight
point_at < 2.9,.5, 2.75>
radius .1
falloff 60
#if (AreaLite) area_light 3*y, 3*z, 9, 9 adaptive 0 jitter circular orient #end
#if (Photons) photons { refraction on reflection on } #end
}
#if(L2)
light_source {
<3,6,8>
rgb 1.1
spotlight
point_at <3,-2,2.75>
radius .15
falloff 10
#if (Photons) photons { refraction on reflection on } #end
}
#end


light_source {
< 4, 6,-2>
rgb .2
spotlight
point_at <-3.12,4.05,8.2> //+ <-3.12,4.05,8.2>*-1
radius .1
falloff 22// + 56
}

     /*
light_source {
< 3, -1,-5>
rgb .5
spotlight
point_at <-1,-1,-4> //+ <-3.12,4.05,8.2>*-1
radius 30
falloff 50// + 56
}   */


#if (_stereo_) #version 3.63; #end
camera {
#if (_stereo_)
    stereoscopic
    zeroparallax 31
    eyeseparation 1
#end 
  up y
  right x*image_width/image_height
   location  < 0.4, 8.3,-30.4>
   look_at   < 0.0, 1.75, 0.0>//< 0.6, 1.75, 0.0>
   angle 22
   
   #if (FocalBlur)
  // aperture keyword followed by a float value which determines the
  // depth of the sharpness zone. Large apertures give a lot of blurring,
  // while narrow apertures will give a wide zone of sharpness. .05 infocus. 1.5 lots of blur
    aperture DOF
    focal_point < 3, 2, 2.75>
    //maximum number of samples, stops shooting rays when a certain degree of confidence has been reached 
    blur_samples 150 //256        // 4-20 ?
    confidence 0.9
    
    // The variance value specifies an acceptable tolerance on the variance of the samples taken so far.
    // In other words, the process of shooting sample rays is terminated when the estimated color value
    // is very likely (as controlled by the confidence probability) near the real color value. 

    variance 1/64 //256 // 1/10000
    // Larger confidence values give more samples, slower traces and better images.
    // Smaller variance threshold for more samples.   default 1/128
  #end
}


#macro tex(col)
  material {
	texture {
	pigment { rgbft col }
	//pigment { rgbt 1 }
	#if (NORMALS) //normal { bumps .1 scale .002 }
	  normal { n_Sea scale n_Scale } // <2.1,4.8,2.1> // 2.1 } //<1,1.8,1> }
	#end
	#if (1)
	finish { ambient .06 diffuse .4 brilliance 1.2 specular .92

                #if (NORMALS) roughness .001
                #else roughness .001
                #end
                metallic .07
                #if (REFLECTIONS)
                  reflection { .06,.5 metallic .07 fresnel 1 exponent 1.2 falloff 2 }
                  conserve_energy
                #end
	}
	
	#end
	}
	interior {
		#if (REFRACTION) ior REFRACTION #end
		fade_power 2 fade_distance .02 fade_color rgbft col+FT
		#if (MEDIA)
	    media {
                 intervals 8 samples 2,6
                 emission 3.81*(col)
                 absorption 12*(1-col)
                 #if (SCATT) scattering { 0, (col)*7 extinction 1 } #end
                 scale .2
                 #if (1)
                 density {
                     bumps scale .002
                     color_map {[0 rgb 1][.5 rgb 1][.56 rgb 0][1 rgb 0]}
                 }
                 #end
         }
		#end
	}
  }
  #if (Photons) photons { target refraction on } #end
  hollow
#end







#declare P_marblewall = pigment { 
    marble
    turbulence x*5
    color_map {
      
      [0.0  rgb <0.99,0.9,0.73>*1.2]
      [0.8  rgb <1.08,0.88,0.6>]
      
    }
    scale 2
}

#declare P_marble = pigment { 
    marble
    turbulence x*3
    color_map {
      [0.0  rgb <0.5,0.4,0.2>*1.3]
      [0.25  rgb <0.92,0.82,0.4>]
      
    }
    scale <4,1,14>
}
#declare P_marble2 = pigment { 
   rgb <0.218,0.0,0.0>
}
#declare P_marble22 = pigment { 
    marble
    turbulence x*5
    color_map {
      [0.0  rgb <0.015,0.015,0.015>]
      [0.2  rgb <0.2,0.2,0.2>]
      
    }
    scale 4
}
#macro _sq(p)
     object { box { <-1.0,-0.01,-1.0>, < 0.0,-.2,0.0> }
      translate p }
#end     
#macro darksqs()
   #local i=0;#local j=0;
   #while (i<42)
      #local j=0;
      #while (j<42)
         #if (mod(i+j,2)) _sq(<-8+j,-4,-32+i>) #end
         #local j=j+1;
      #end
   #local i=i+1;
   #end
#end

#macro litesqs()
   #local i=0;#local j=0;
   #while (i<42)
      #local j=0;
      #while (j<42)
         #if (!mod(i+j,2)) _sq(<-8+j,-4,-32+i>) #end
         #local j=j+1;
      #end
   #local i=i+1;
   #end
#end
#macro tilefloor()
union {
  union {
    darksqs()
    texture { P_marble2 finish { ambient 0.03 diffuse .7  specular 1 reflection 0.05 } }
    #if (Photons) photons { collect on refraction on } #end
  }
  union {
    litesqs()
    texture { P_marble finish { ambient 0.2 diffuse .6 specular 1 reflection 0.05 } }
    #if (Photons) photons { collect on refraction on } #end
  }
}  
#end


#declare Glass1 = texture {
   pigment {rgbf < 0.98, 1.0, 0.98, 1> }
   finish {
      specular 1
      roughness 0.001
      ambient 0
      diffuse 0
      reflection {
         0,1
         fresnel
      }
   }
}

#declare Glass = texture {
   pigment {rgbft < 0.98, 1.0, 0.98,.02,.95> }
   finish {
      specular 1
      roughness 0.001
      ambient 0
      diffuse 0
      reflection {
         0,1
         fresnel
      }
   }
}
#declare Finsh_Glass =
finish {
  ambient 0.005
  diffuse 0.1
  reflection 0.05
  specular 0.8
  roughness 0.003
  phong .7
  phong_size 800
}
   
#declare sky_white =
sky_sphere {
    pigment {
        gradient y
        color_map {
          [0.0 rgb <0.99,0.99,0.99>]
          [1.0 rgb <0.6,0.6,0.6>]
        }
    }
}
#declare sky_blue =
sky_sphere {
    pigment {
        gradient y
        color_map {
          [0.0 rgb <0.6,0.7,1.0>]
          [0.7 rgb <0.4,0.5,0.8>]
        }
    }
}    //sky_sphere { sky_blue }



#declare molding= superellipsoid {
   < 0.037, 0.037>       
  translate < 0, 1, 0>
  texture {
     pigment { rgb <.99,.99,.88> }
     finish { ambient 0.6 diffuse .6 }
   }
   scale <10,.2,1>
   translate <0,-3.95,9.6>
}
object { molding rotate y*90 }
object { molding rotate y*-90 }
object { molding rotate y*180 translate z*(-31.5+9) }
object { molding rotate 0 }
  
 
#declare walls =
object { box { <-1,-1,-3.5>, < 1,4,1> hollow }
     texture {
     pigment { P_marblewall }
     finish { ambient 0.17 diffuse .6 }
   }      
   scale <9,9,9>
   translate < 0, -4, 0>
}
#macro cdot(p) 
 object {
   disc { 0,-z .035 pigment {rgb <.4,0,.0>} finish { ambient 0.6 diffuse .6 }
   translate p
  }
} #end
#macro txtn(p,Txt)
   text {
      ttf "Arial.ttf" 
      Txt
      1 x*.005
      scale .174
      texture { pigment {rgb 1} finish { ambient .6 diffuse .6 } }  
      translate p-z*.01
      translate <-.04,-.07,0>
   }
#end  
#macro cloknums()
 #local i=0;#local j=0; #local p = <0,0.594,0>;//.13*4.575= 0.59475
     #local rd = 360/12;
     #while (i < 12)
        #if (i+1 = 10) txtn(vaxis_rotate(p+<-.01,.03,0>,-z,rd*(i+1)),str(i+1,0,0))
        #else #if (i+1 = 11) txtn(vaxis_rotate(p+<-.06,.01,0>,-z,rd*(i+1)),str(i+1,0,0))
        #else #if (i+1 = 12) txtn(vaxis_rotate(p+<-.03,.005,0>,-z,rd*(i+1)),str(i+1,0,0))
        #else txtn(vaxis_rotate(p,-z,rd*(i+1)),str(i+1,0,0))
        #end #end #end
        #local i=i+1;
     #end
#end
#macro wallclock()
#local clokpos = <-3.06,4.05,8.2>;   //_____________________________________________//T
union {
    cylinder {  <0,0,0>, <0,1,0>, .755
      texture { pigment {rgb <.95,.95,1>} finish { ambient 0.6 diffuse .6 reflection 0.05 } }  
      rotate x*90
      translate z*.1
    }
    //min hand
    cylinder {  <0,0,0>, <0,.54,0>, .02
      texture { pigment {rgb 0} finish { ambient 0.6 diffuse .6 reflection 0.05 } }  
      rotate z*(360/60)*-8
    }
    //hour hand
    cylinder {  <0,0,0>, <0,.38,0>, .03
      texture { pigment {rgb 0} finish { ambient 0.6 diffuse .6 reflection 0.05 } }  
      rotate z*(360/60)*-25
    
    }
    union {
       disc { 0,-z,.714, .45 
       texture { pigment {rgb <.4,0,.0>} finish { ambient 0.4 diffuse .6 } }
       }
       cloknums()

       #local b = .13;
       cdot(<0,0,0>)
       
       cdot( y*b*2)
       cdot( y*b*2+y*b+x*b)
       cdot( y*b*2+y*b+x*-b)
       
       cdot( y*b+x*b)
       cdot( x*b*2)
       
       cdot( x*b*2+x*b+y*b)
       cdot( x*b*2+x*b+y*-b)
       
       cdot( y*b*2+x*b*2)
       
       #local b = -b;
       cdot( y*b*2)
       cdot( y*b*2+y*b+x*b)
       cdot( y*b*2+y*b+x*-b)
       
       cdot( y*b+x*b)
       cdot( x*b*2)
       
       cdot( x*b*2+x*b+y*b)
       cdot( x*b*2+x*b+y*-b)
       
       cdot( y*b*2+x*b*2)
           
       cdot( y*b*-2+x*b*2)
       cdot( y*-b+x*b)
       
       
       #local b = -b;
       cdot( y*b*-2+x*b*2)
       cdot( y*-b+x*b)
       translate z*.05
    }
    rotate <1,-1,0>
    translate clokpos
}
#end
          /*
#declare bowl = difference {
 cylinder {  <0,0,0>, <0,.3,0>, .38 }
 sphere { <0,0,0>,.5 scale <1,.5,1> translate <0,.34,0> }
      texture { pigment {rgb <0,0,.3>} finish { ambient 0.2 diffuse .6 reflection 0.05 } }
}      

#include "somewood.inc"

#declare chair = union {

      box {<-.1,0,-.1>, < .1,1.8,.1> translate <-1,0,-1> }
      box {<-.1,0,-.1>, < .1,1.8,.1> translate <1,0,-1> }
      //seat
      box {<-1.1,0,-1.1>, <1.1,.25,1.1> translate <0,1.6,0> }
      //back legs
      box {<-.13,0,-.13>, < .13,4.65,.13> translate <-1,0,1> }
      box {<-.13,0,-.13>, < .13,4.65,.13> translate <1,0,1> }
      
      //leg support
      box {<-1,0,-.05>, <1,.2,.05> translate <0,.5,-1> }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,.5,-1> rotate y*90 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,.5,-1> rotate y*-90 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,.5,-1> rotate y*180 }
      
      //back
      box {<-1,0,-.05>, <1,.2,.05> translate <0,3.1,-1> rotate y*180 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,3.4,-1> rotate y*180 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,3.7,-1> rotate y*180 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,4.0,-1> rotate y*180 }
      box {<-1,0,-.05>, <1,.2,.05> translate <0,2.4,-1> rotate y*180 }
      texture { darkwood }      
}              */

  
#macro dot(p,c) 
 object {
   disc { 0,-z .06 pigment {rgb c} finish { ambient 0.2 diffuse .6 }
   translate p

  } } #end
  
#macro wallpaper()
   #local c = <0,.4,.0>;
   #local i=0;#local j=0;
   #while (i<42)
      cylinder { <i*.573-.075,-4,9> <i*.573+.625,4*9-4,9> .045
           pigment { rgb <.64, 0.152,0> }
           finish { ambient 0.2 diffuse .6 }
           translate x*-8.49
      }
      #if (mod(i,2)) #local c = <0,.1,.0>;
      #else #local c = <.4,0,.0>; #end
      #local j=0;
      #while (j<42)
         // #if (!mod(i+j,2)) dot(<-8.2+j*.573,-4.1+i*.36,8.99>,c) #end
         // match skew
         #if (!mod(i+j,2)) dot(<(-8.2+j*.573)+(i-11)*(.3/42),-4.2+i*.363+j*.005,8.99>,c) #end
         #local j=j+1;
      #end
   #local i=i+1;
   #end
#end

#declare rope =
sphere_sweep {
b_spline 16,
<.05,8,0>,.06
<.05,7.5,.05>,.06
<0,7.2,0>,.06
<.08,6.8,0>,.06
<0,5.8,0>,.06
<0,5.5,0>,.06

<-.5,4.4,0>,.06
<-.6,4.25,-.7>,.06

<-.3,4.25,-1.8>,.06
<.3,4.25,-1.8>,.06

<.65,4.25,-.7>,.06
<.3,4.4,0>,.06

<0,5.5,0.0>,.06
<0,5.8,.05>,.06
<.1,6.1,.1>,.06
<.5,6.5,.5>,.06

 tolerance 1.0e-6 
}

#if (Noose)
#declare noose = union {
      object { rope }
      torus { .1,.05 translate <.04,5.86,0> }
      torus { .1,.05 translate <.03,5.79,0> }
      torus { .1,.05 translate <.02,5.72,0> }
      torus { .1,.05 translate <.01,5.65,0> }
   texture { pigment {rgb 1} finish { ambient 0.3 diffuse .5 } }

   translate <0,-2.0,1.05> rotate y*4  
   }
#end

#if (Cat) #include "cat_sit_m_POV_geom.inc"
     object{ cat_sit_m_ scale .03 rotate y*-165 translate <-5,-4,7> }
#end

#if(Book)#include "bookmake.inc"
  #declare fpages = array[4] {" ","cliffs.jpg","Katie_Anderson_04.jpg","06-lrg_8.jpg"}
  #declare bpages = 6;
  #declare prnt = array[bpages*2] {1,3,1,2,1,3,1,2,1,3,1,2}   //     collate scheme
  object { book(1.7,2.0,45) rotate x*25 
                 rotate z*-3 rotate y*26 translate <2.2, 2.9, 0.3>//____________//T
  }  //object { book(7,6.0,60) rotate x*90 rotate y*180 translate <0,1,0> }
#end
#if (CubeDraw)                                    #declare n_Scale = <2.05,4.8,2.05>;
 #declare mcube= superellipsoid { <0.19, 0.19> translate <0,1,0> tex(<.96,.975,1>) }
 object { mcube rotate y*35 scale <1.9,1.78,1.9> translate <2.9, -4, 2.75> }    //T
#end #if (0) #include "legoman_.pov"
object {  pilot rotate z*-3 rotate y*26 translate < 3.2, 1.85, 2.5> } #end      //T

#if (Noose) 
 object { noose rotate z*-3 rotate y*26 translate <3.2, 1.85, 2.55> } #end      //T
//object {  chair rotate z*-3 rotate y*26 translate <2.99, -0.4, 2.5> }           //T


#if (Puddle) #include "puddle2.pov"           #declare n_Scale = <2,9,2>*1;
  object { puddle(.1) tex(<.9,.95,1>)
   //texture { pigment {rgb <1,0,1> } finish { ambient 0.3 diffuse .5 } }
   translate < 2.9, -3.983, 2.75>                                               //T
  }
#end
object { walls } 
//wallpaper()
wallclock()
object { tilefloor() translate z*-.1 } // y @ -4.01
//object { bowl scale 1.3 translate <-3.4, -4, 6.5> }


#declare S1 = seed (2341);
#declare S2 = seed (5521);
#declare S3 = seed (134515);
#declare n_Scale = <2.05,4.8,2.05>;
#include "bezier2.inc"
        // wallclock
        union {
          sweep_rc(0.24,0.001,.585)    //.585=232 points    .587=230 pnts    .589=229 pnts
          scale .18
          translate <-3.1,4.0,8.995>
        }
#if (0)
        union {
          sweep_rc(0.54,0.001,.585) // radius detail dist-between-pnts
          //texture { pigment {rgb <.5,.8,1> } finish { ambient 0.3 diffuse .5 } }
          scale .5
          translate y*2
          translate z*.25
        }
        object { pov_P_prism scale <.5,.5,.5> tex(<.91,.25,1>)
            rotate x*-90  translate y*2 }
#else
#if (0)        
        
        #declare pmonster = union {
           object { pov_P_prism scale <.5,.25,.5> tex(<.91,.25,1>)
            rotate x*-90 }
           #if (10)
           union {
              sweep(0.15,0.001,.07) //.0585 = 2248 points  .07 = 1892 with kappa bez circle
              scale .5
              texture { T_Chrome_3C }
           }
           //#if (0) 
           union {
              sweep(0.15,0.001,.07)
              scale .5
              texture { T_Chrome_3C }
              translate z*.25
           }#end
           //texture { pigment {rgb <.5,.8,1> } finish { ambient 0.3 diffuse .5 } }
           scale 1.05
           translate y*2
           //translate y*19.525406 * .5
        }
        
        
        #if (_mblur)
            #declare mblurtype = 1;
            motion_blur { type mblurtype
                    object { pmonster translate x*clock }
            }        
        #end 
        object { pmonster translate <.4,.3,-.001> }
#end
#end

//#include "triangulation.inc"
#include "spheroid_dome.inc"
#macro sweep_pnts_array(Radius,detail,dist,arr,sw) //(0.24,0.001,.585)    //.585=232 points    .587=230 pnts    .589=229 pnts

    #declare J=0;         // capital J = global counter
    #declare Prev = arr[0]*10;
    // start out of range

    #local i=0;
    #while (i < dimension_size(arr,1)/4)
      point_spread_count(
        <arr[i*4].x,0,arr[i*4].y>,
        <arr[i*4+1].x,0,arr[i*4+1].y>,
        <arr[i*4+2].x,0,arr[i*4+2].y>,
        <arr[i*4+3].x,0,arr[i*4+3].y>,
        detail,dist,Radius
      )

      #local i=i+1;
    #end
    
    #if (sw) #declare aSpline = array [J]
    #else #declare bSpline = array [J]
    #end
    
    #declare J=0;         // capital J = global counter
    #declare Prev = arr[0]*10;
    // start out of range

    #local i=0;
    #while (i < dimension_size(arr,1)/4)
      point_spread(
        <arr[i*4].x,0,arr[i*4].y>,
        <arr[i*4+1].x,0,arr[i*4+1].y>,
        <arr[i*4+2].x,0,arr[i*4+2].y>,
        <arr[i*4+3].x,0,arr[i*4+3].y>,
        detail,dist,Radius,sw
      )

      #local i=i+1;
    #end
    echo("Created ") echoi(J) echo(" points*****///////SWEEP///////*****\n")
    

#end

#macro point_spread(P1,H1,H2,P2,detail,dist,Radius,sw)
             //(<x,y,0>3D input<x,0,y>, 0.001,   1,      )
     #local C = 3*(H1-P1);
     #local B = 3*(H2-H1)-C;
     #local A = P2-P1-C-B;
     
     #local i = 0; #local XYZ=P1;
     // do something with point1 (P1) --- start out of loop2 range, from start macro
     
     #while (i<1)
         #while ((i<1) & (vlength(XYZ-Prev)<dist))
             #local XYZ= A*pow(i,3)+B*pow(i,2)+C*i+P1;
             #local i=i+detail;
         #end
         #if (vlength(XYZ-Prev)>=dist)
           // set spline array
           #if (sw) #declare aSpline[J] = XYZ;
           #else #declare bSpline[J] = XYZ;
           #end
           #declare J=J+1;
           #declare Prev=XYZ;
         #end
     #end
#end

#macro point_spread_count(P1,H1,H2,P2,detail,dist,Radius)
     #local C = 3*(H1-P1);
     #local B = 3*(H2-H1)-C;
     #local A = P2-P1-C-B;
     #local i = 0; #local XYZ=P1;
     #while (i<1)
         #while ((i<1) & (vlength(XYZ-Prev)<dist))
             #local XYZ= A*pow(i,3)+B*pow(i,2)+C*i+P1;
             #local i=i+detail;
         #end
         #if (vlength(XYZ-Prev)>=dist)
                           // do nothing, just counting
           #declare J=J+1;
           #declare Prev=XYZ;
         #end
     #end
#end




#declare bakbone = array [32] {
<-8.97748,-19.186798>,<-8.600712,-18.26049>,<-3.907884,-7.844264>,<-3.587422,-6.853213>,
<-3.587422,-6.853213>,<-2.311758,-7.262543>,<-1.334273,-7.407516>,<0.076719,-7.35982>,
<0.076719,-7.35982>,<2.300471,-7.315497>,<3.818782,-6.533337>,<4.946773,-5.736469>,
<4.946773,-5.736469>,<6.671365,-4.73897>,<7.775592,-3.17465>,<8.005639,-1.840377>,
<8.005639,-1.840377>,<8.36689,-0.816883>,<8.235686,1.334273>,<7.637563,2.484509>,
<7.637563,2.484509>,<6.906766,3.889887>,<5.797187,5.52113>,<3.705387,6.390921>,
<3.705387,6.390921>,<0.998752,7.490637>,<-1.781958,7.439811>,<-3.456457,6.963868>,
<-3.456457,6.963868>,<-5.302762,6.439068>,<-7.487382,4.911723>,<-8.405834,3.733708>
}
/*
<-8.97748,-19.186798>,<-8.600712,-18.26049>,<-3.661644,-8.090255>,<-3.290532,-7.125362>,
<-3.290532,-7.125362>,<-1.880304,-7.298548>,<-1.334273,-7.407516>,<0.076719,-7.35982>,
<0.076719,-7.35982>,<2.300471,-7.315497>,<3.818782,-6.533337>,<4.946773,-5.736469>,
<4.946773,-5.736469>,<6.671365,-4.73897>,<7.775592,-3.17465>,<8.005639,-1.840377>,
<8.005639,-1.840377>,<8.36689,-0.816883>,<8.235686,1.334273>,<7.637563,2.484509>,
<7.637563,2.484509>,<6.906766,3.889887>,<5.797187,5.52113>,<3.705387,6.390921>,
<3.705387,6.390921>,<0.998752,7.490637>,<-1.781958,7.439811>,<-3.456457,6.963868>,
<-3.456457,6.963868>,<-5.302762,6.439068>,<-7.487382,4.911723>,<-8.405834,3.733708>
}   */
/*
<-8.97748,-19.186798>,<-8.600712,-18.26049>,<-3.612162,-8.263441>,<-3.24105,-7.298548>,
<-3.24105,-7.298548>,<-1.830822,-7.471734>,<-1.334273,-7.407516>,<0.076719,-7.35982>,
<0.076719,-7.35982>,<2.300471,-7.315497>,<3.818782,-6.533337>,<4.946773,-5.736469>,
<4.946773,-5.736469>,<6.671365,-4.73897>,<7.775592,-3.17465>,<8.005639,-1.840377>,
<8.005639,-1.840377>,<8.36689,-0.816883>,<8.235686,1.334273>,<7.637563,2.484509>,
<7.637563,2.484509>,<6.906766,3.889887>,<5.797187,5.52113>,<3.705387,6.390921>,
<3.705387,6.390921>,<0.998752,7.490637>,<-1.781958,7.439811>,<-3.456457,6.963868>,
<-3.456457,6.963868>,<-5.302762,6.439068>,<-7.487382,4.911723>,<-8.405834,3.733708>
}                                                                                           */
 /*
<-8.97748,-19.186798>,<-8.600712,-18.26049>,<-4.402701,-7.943228>,<-4.048829,-6.993431>,
<-4.048829,-6.993431>,<-2.806575,-7.361507>,<-1.334273,-7.407516>,<0.076719,-7.35982>,
<0.076719,-7.35982>,<2.300471,-7.315497>,<3.818782,-6.533337>,<4.946773,-5.736469>,
<4.946773,-5.736469>,<6.671365,-4.73897>,<7.775592,-3.17465>,<8.005639,-1.840377>,
<8.005639,-1.840377>,<8.36689,-0.816883>,<8.235686,1.334273>,<7.637563,2.484509>,
<7.637563,2.484509>,<6.906766,3.889887>,<5.797187,5.52113>,<3.705387,6.390921>,
<3.705387,6.390921>,<0.998752,7.490637>,<-1.781958,7.439811>,<-3.456457,6.963868>,
<-3.456457,6.963868>,<-5.302762,6.439068>,<-7.487382,4.911723>,<-8.405834,3.733708>
}                                                                                         */
#declare P_center = array [16] {
<0,-3.7704>,<-2.082334,-3.7704>,<-3.7704,-2.082334>,<-3.7704,0>,
<-3.7704,0>,<-3.7704,2.082334>,<-2.082334,3.7704>,<0,3.7704>,
<0,3.7704>,<2.082334,3.7704>,<3.7704,2.082334>,<3.7704,0>,
<3.7704,0>,<3.7704,-2.082334>,<2.082334,-3.7704>,<0,-3.7704>
}
#declare P_cen = array [4] {
<0,0>,<0,0>,<0,0>,<0,0>
}

#macro bezier_pnt(P1,H1,H2,P2,T) // <x,y> or <x,y,0,> or <x,0,y>
           //(node, ctrlh, ctrlh, node, .01)
     #local C = 3*(H1-P1);
     #local B = 3*(H2-H1)-C;
     #local A = P2-P1-C-B;
     A*pow(T,3)+B*pow(T,2)+C*T+P1
#end

#macro bezPrism(exH,rm1,rm2,slices,Switch)   // extrusionheight,radiusmod1,radiusmod2
   #declare NumVertices = int((dimension_size(aSpline, 1)+dimension_size(bSpline, 1))*slices*1.32); // must be reset to actual
   //I dont Know!!

   #declare V_vec_Arr=array[NumVertices] 
   #declare N_vec_Arr=array[NumVertices] 
   #declare UV_vec_Arr=array[NumVertices]
   #declare NumEdges = 0;
   #declare Edge_Arr=array[NumVertices*3]
   #declare NumFaces = 0;
   #declare Face_Arr=array[NumVertices*2]
   cr() echof(NumVertices) echo(" Allocated")
  
   #local hr = y*exH*kappa;
   #local hr = hr +  y*exH*(1-kappa)*rm2;
  
  #local Swtch = 0;
  #local aa = 0;
  #local i = 0;
  #local j = 0;
  #local incdec = 1;
  #local k = 0;
  
  #local dtheta = 1 / (slices-1);
  #local s1 = 1; #local s2 = 1; #local e1 = 1; #local e2 = 1; #local n=1; #local trap = 1;
  
  #while (i <= dimension_size(bSpline, 1))
    #local j = 0;
    #if (i = dimension_size(bSpline, 1)) #local ipnt = bSpline[0];
    #else #local ipnt = bSpline[i];
    #end
    
    #local aapnt = aSpline[aa]+<0,exH,0>;
    #local wr = (ipnt+y*exH-aapnt)*kappa;
    #local wr = wr+      (ipnt+y*exH-aapnt)*(1-kappa)*rm1; //radius modifier 1
    #local V=RangeMM(i,0,dimension_size(bSpline, 1),Vmin,Vmax);
    #while (j < slices)
       #local U=RangeMM(j,0,slices,Umin,Umax); // min max radians
       #declare UV_vec_Arr[k]=<U,V>;
       
       #declare V_vec_Arr[k] = bezier_pnt(ipnt,ipnt+hr,aapnt+wr,aapnt,j*dtheta);
       #declare N_vec_Arr[k] = vnormalize(V_vec_Arr[k]-aSpline[aa]);
      #local k=k+1; #declare NumVertices = k;
      #local j=j+1;
    #end

    #if (i) 
      #if (Swtch) stripfaces2(k-slices*2,(k-1)-slices,(k-slices)+1,k-1)
                  stripedges2(k-slices*2,(k-1)-slices,(k-slices)+1,k-1)
                  #local Swtch = 0;
      #else stripfaces2(k-slices*2,(k-1)-slices,k-slices,k-2)
            stripedges2(k-slices*2,(k-1)-slices,k-slices,k-2)
      #end
    #end
    #local i=i+1;      #if (1) // for pov logo only                                             // corner of 50
                          #if ((i>44) & (i<52)) #local trap = 0;   // fix for perimeter not following bakbone
                          #else #local trap = 1; #end
                       #end
    #if (aa+1 >= dimension_size(aSpline, 1)) #local incdec = -1; #end            // asplinelen >= 2 even if same point
    #if ((aa+incdec > -1) & (i < dimension_size(bSpline,1)))     // stay in range
         #if ((vlength(aSpline[aa+incdec]-bSpline[i])<vlength(aSpline[aa]-bSpline[i])) & (trap))
             #local aa=aa+incdec;
             // if next backbone pnt is closer, use it
             #local Swtch = 1;
             #local i=i-1;  // dont goto next perimeter pnt
         #end
    #end
  #end
  
  echo("\nNum Verts ************* ")
  echoi(NumVertices)
  echo("\nStripping Faces ******* ")
  echoi(NumFaces)
  echo("\nStripping Edges ******* ")
  echoi(NumEdges) cr() cr()
#end


//////////////////////////////// Rotator \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ 
#macro bezPrism_r(exH,rm1,rm2,m1,m2,slices,Switch)   // extrusionheight,radiusmod1,radiusmod2, rotation inwards times 45 deg w/h
   #declare NumVertices = int((dimension_size(aSpline, 1)+dimension_size(bSpline, 1))*slices*1.32); // must be reset to actual
   //I dont Know!!

   #declare V_vec_Arr=array[NumVertices] 
   #declare N_vec_Arr=array[NumVertices] 
   #declare UV_vec_Arr=array[NumVertices]
   #declare NumEdges = 0;
   #declare Edge_Arr=array[NumVertices*3]
   #declare NumFaces = 0;
   #declare Face_Arr=array[NumVertices*2]
   cr() echof(NumVertices) echo(" Allocated")
  
   #local hr = y*exH*kappa;
   #local hr = hr +  y*exH*(1-kappa)*rm2;
  
  #local Swtch = 0;
  #local aa = 0;
  #local i = 0;
  #local j = 0;
  #local incdec = 1;
  #local k = 0;
  
  #local dtheta = 1 / (slices-1);
  #local s1 = 1; #local s2 = 1; #local e1 = 1; #local e2 = 1; #local n=1; #local trap = 1;
  
  #while (i <= dimension_size(bSpline, 1))
    #local j = 0;
    #if (i = dimension_size(bSpline, 1)) #local ipnt = bSpline[0];
    #else #local ipnt = bSpline[i];
    #end
    
    #local aapnt = aSpline[aa]+<0,exH,0>;
    #local wr = (ipnt-aSpline[aa])*kappa;
    #local _v = vcross(y,wr);
    #local wr = wr+ (ipnt-aSpline[aa])*(1-kappa)*rm1; //radius modifier 1 
    
       // handle rot
       #local wr = rotation(radians(45*m1),_v,wr);
       #local hr = y*exH*kappa;
       #local hr = hr +  y*exH*(1-kappa)*rm2;
       #local hr = rotation(radians(-45*m2),_v,hr);

       
       
    #local V=RangeMM(i,0,dimension_size(bSpline, 1),Vmin,Vmax);
    #while (j < slices)
       #local U=RangeMM(j,0,slices,Umin,Umax); // min max radians
       #declare UV_vec_Arr[k]=<U,V>;

       #declare V_vec_Arr[k] = bezier_pnt(ipnt,ipnt+hr,aapnt+wr,aapnt,j*dtheta);
       #declare N_vec_Arr[k] = vnormalize(V_vec_Arr[k]-aSpline[aa]);
      #local k=k+1; #declare NumVertices = k;
      #local j=j+1;
    #end

    #if (i) 
      #if (Swtch) stripfaces2(k-slices*2,(k-1)-slices,(k-slices)+1,k-1)
                  stripedges2(k-slices*2,(k-1)-slices,(k-slices)+1,k-1)
                  #local Swtch = 0;
      #else stripfaces2(k-slices*2,(k-1)-slices,k-slices,k-2)
            stripedges2(k-slices*2,(k-1)-slices,k-slices,k-2)
      #end
    #end
    #local i=i+1;      #if (1) // for pov logo only                                             // corner of 50
                          #if ((i>44) & (i<52)) #local trap = 0;   // fix for perimeter not following bakbone
                          #else #local trap = 1; #end
                       #end
    #if (aa+1 >= dimension_size(aSpline, 1)) #local incdec = -1; #end            // asplinelen >= 2 even if same point
    #if ((aa+incdec > -1) & (i < dimension_size(bSpline,1)))     // stay in range
         #if ((vlength(aSpline[aa+incdec]-bSpline[i])<vlength(aSpline[aa]-bSpline[i])) & (trap))
             #local aa=aa+incdec;
             // if next backbone pnt is closer, use it
             #local Swtch = 1;
             #local i=i-1;  // dont goto next perimeter pnt
         #end
    #end
  #end
  
  echo("\nNum Verts ************* ")
  echof(NumVertices)
  echo("\nStripping Faces ******* ")
  echof(NumFaces)
  echo("\nStripping Edges ******* ")
  echof(NumEdges) cr() cr()
#end


#macro oldtex( col )
  pigment { rgbft col }
  //normal { bumps .1 scale .002 }
  finish {
    ambient .01 diffuse .4 brilliance 1.2
    //specular .97
    roughness .02
    metallic .1
    //reflection { .2,.9 metallic .1 fresnel on exponent 1 }
    conserve_energy
  }
#end

#declare S1 = seed (987);
#declare S2 = seed (7879);
#declare S3 = seed (9979);

#macro FaceEdgeMetal(Radius)
  #local i = 0;
  union {
  #while (i<NumFaces)
    #if(!VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y]) &
        !VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z]) &
        !VEq(V_vec_Arr[Face_Arr[i].z], V_vec_Arr[Face_Arr[i].y]) )
       
       cylinder { V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y], Radius }
       cylinder { V_vec_Arr[Face_Arr[i].y], V_vec_Arr[Face_Arr[i].z], Radius }
       cylinder { V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z], Radius }
    
     #else echo("Bad Triangle ")
     #end
  #local i = i+1;
  #end
  
  texture { T_Chrome_3C }
  }
#end

#macro VertexSpheres(Radius)
   #local i=0;
   #while (i<NumVertices)
     sphere{V_vec_Arr[i], Radius}
     #local i=i+1; 
   #end
#end

#macro By_Edges(Radius)
  #local i=0;   
  #while (i<NumEdges)
    #if (!VEq(V_vec_Arr[Edge_Arr[i].x],V_vec_Arr[Edge_Arr[i].y]))
      cylinder { V_vec_Arr[Edge_Arr[i].x],V_vec_Arr[Edge_Arr[i].y],Radius }
    #else echo("Warning By_Edges(): Bad Cylinder, skipping it \n")
    #end
    #local i = i+1;
  #end        
#end

#macro QuadFaces(rswitch,C)
   
      #local i = 0;
      #while (i<NumFaces)
        union {
                #if(!VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y]) &
                   !VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z]) &
                   !VEq(V_vec_Arr[Face_Arr[i].z], V_vec_Arr[Face_Arr[i].y]) )
                  triangle { V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y], V_vec_Arr[Face_Arr[i].z] }
                                   
                #else echo("Warning By_Edges(): Bad Triangle, skipping it \n")
                #end
                #local i = i+1;
                
                #if (i < NumFaces)
                    #if(!VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y]) &
                       !VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z]) &
                       !VEq(V_vec_Arr[Face_Arr[i].z], V_vec_Arr[Face_Arr[i].y]) )
                      triangle { V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y], V_vec_Arr[Face_Arr[i].z] }
                    
                    #else echo("Bad Triangle ")
                    #end
                #end
                #local i = i+1;
        
                      #if (rswitch) texture {
                     oldtex(<rand(S3),rand(S2),rand(S1),.9,.1>) }
                     //#else oldtex(C)
                     #end
                     //tex(<rand(S3),.2,rand(S1),.9,.1>)
         }
     #end
#end

#macro Triangles(rswitch,C)
  #local i = 0;
  //union { // works also
  mesh {
  #while (i<NumFaces)
    #if(!VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y]) &
        !VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z]) &
        !VEq(V_vec_Arr[Face_Arr[i].z], V_vec_Arr[Face_Arr[i].y]) )
       triangle {V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y], V_vec_Arr[Face_Arr[i].z]
          
                  #if (rswitch) texture {
                  oldtex(<rand(S3),rand(S2),rand(S1),.9,.1>) }
                  //#else oldtex(C)
                  #end
                  //tex(<rand(S3),.2,rand(S1),.9,.1>)
    
     }
     #else echo("Bad Triangle ")
     #end // unecessary condition, there are NO degenerate triangles, code is correct, debug.
  #local i = i+1;
  #end
  }
#end
 
#macro SmoothTriangles(c)
     #local i=0;
     //union {   //"degenerate triangle" created using union, use mesh{}
     mesh {
        #while (i<NumFaces)
          /* #if(!VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].y]) &
               !VEq(V_vec_Arr[Face_Arr[i].x], V_vec_Arr[Face_Arr[i].z]) &
               !VEq(V_vec_Arr[Face_Arr[i].z], V_vec_Arr[Face_Arr[i].y]) )  */
             smooth_triangle {
               V_vec_Arr[Face_Arr[i].x]
               N_vec_Arr[Face_Arr[i].x]
               V_vec_Arr[Face_Arr[i].y]
               N_vec_Arr[Face_Arr[i].y]
               V_vec_Arr[Face_Arr[i].z]
               N_vec_Arr[Face_Arr[i].z]
             }
           // unecessary #end
           #local i=i+1;
        #end
        //oldtex(c)
     }
#end
////////////////////P SWEEPS\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
// set bSpline[], an even pnt spread along multiple bezier paths
//sweep_pnts_array(0.24,0.001,.585,P_bez_noc,0)           // bSpline  perimeter
//sweep_pnts_array(0.24,0.001,.585,bakbone,1)         // aSpline  .585=86

#declare Vmin=PI_5;#declare Vmax=PI_5;
#declare Umin=0;#declare Umax=PI_5;
#if (0)
       bezPrism(3,0,0,10,0)
       object {
         Triangles(0,<.9,.3,.4,.9,.1>) 
         tex(<.7,.1,.4,0,0>)
         rotate <-90,0,0>
         scale .3
         translate y*3
         translate x*2.6
       }
#end

#if (0)
       bezPrism_r(5,0,1.7,.2,0,10,0)
       #declare n_Scale = <2.05,3,2.05>;
       union {
       object { Triangles(0,<.9,.3,.4,.9,.1>) tex(<.4,.9,.4,0,0>) }
       object { Triangles(0,<.9,.3,.4,.9,.1>) tex(<.4,.9,.4,0,0>) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
         
         //scale <1,2,1>
         rotate <-90,0,0> 
         scale .3
         translate y*3
         translate x*2.6
       }
#end
#if (0)
       //bezPrism(2,1,1.2,9,0)
       #if (0)
           echo("\nChecking Normals...Estimated Time: ") echof(NumVertices*1.68 / 3258) echo(" Hrs.\n")
           Norms(0)
           //echo("\nChecking Normals...Estimated Time: ") echof(4*(NumVertices*1.68 / 3258) echo(" Hrs.\n")
           //Norms(1)
           WriteMesh("P_logomesh.pov")
           #else #include "P_logomesh_9slic.pov"
       #end    
       #declare Spheroid_Surface=
       mesh2 {
             #local i = 0;
             vertex_vectors {
                NumVertices
                #while (i<NumVertices)
                   V_vec_Arr[i]
                   #local i = i+1; 
                #end
             }
             #local i = 0;
             normal_vectors {
                NumVertices
                #while (i<NumVertices)
                   N_vec_Arr[i]
                   #local i = i+1;
                #end
             }
             #local i = 0;
             uv_vectors {
                NumVertices
                #while (i<NumVertices)
                   UV_vec_Arr[i]
                   //<1,0>
                   #local i = i+1;
                #end
             }
             #local i = 0;
             face_indices {
                NumFaces
                #local i = 0;
                #while (i<NumFaces)
                   Face_Arr[i]
                   #local i = i+1;
                #end
             }
       }
       union {
         object { //SmoothTriangles(<.4,.9,.4,0,0>)  
                //Spheroid_Surface oldtex(<.4,.9,.4,0,0>)
                Psurface //oldtex(<.4,.9,.4,0,0>)
                //Triangles(0,<.9,.3,.4,.9,.1>) oldtex(<.4,.9,.4,0,0>)
         }
         object { Psurface matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
         //oldtex(<.4,.9,.4,0,0>)
         tex(<.7,.1,.4,0,0>)
         scale <1,2,1>
         rotate <-90,0,0> 
         scale .3
         translate y*3
         translate x*-2.6
       }
#end        
#if (0) 

///////////////////// NEW SWEEPS  ___ Logo Center \\\\\\\\\\\\\\\\\\\\\\
//sweep_pnts_array(0.24,0.001,.585,P_center,0)           // bSpline  perimeter
//sweep_pnts_array(0.24,0.001,.585,P_cen,1)
#declare aSpline = array [2] { <0,0,0>,<0,0,0> }

#declare Vmin=0;#declare Vmax=pi;
#declare Umin=0;#declare Umax=pi; 
//bezPrism(2,1,1,10,0)
//Norms(0) // 0=faster index search. 1=slow VEq more accurate
       #if (0)
           echo("\nChecking Normals...Estimated Time: ") echof(NumVertices*.03/420*60) echo(" Mins.\n")
           Norms(0)
           //echo("\nChecking Normals...Estimated Time: ") echof(4*(NumVertices*1.68 / 3258) echo(" Hrs.\n")
           //Norms(1)
           WriteMesh("P_cenmesh.pov")
           #else #include "P_cenmesh.pov"
       #end 

#end 
 
#if (0)
union { 
 
   object { PcenSurface }
   object { PcenSurface matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
   oldtex(<.4,.9,.4,0,0>)
   scale <1,2,1>
   rotate <-90,0,0> 
   scale .3
   translate y*3
   translate x*-2.6
}
#end



#if (0)
object {
  //Triangles(0,<.9,.3,.4,.9,.1>) oldtex(<.4,.9,.4,0,0>)
  Spheroid_Surface   oldtex(<.4,.9,.4,0,0>)
  //SmoothTriangles(<.4,.9,.4,0,0>) 
  
  rotate <-90,0,0> 
  scale .3
  translate y*3
  translate x*-2.6
}
#end
#if (0)
bezPrism(5,1,1.7,10,0)
union {
  object { Triangles(0,<.9,.3,.4,.9,.1>) tex(<.7,.1,.4,0,0>) }
  object { Triangles(0,<.9,.3,.4,.9,.1>) tex(<.7,.1,.4,0,0>) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
  
  rotate <-90,0,0> 
  scale .3
  translate y*3
  translate x*2.6
}
#end

#macro FastNorms77(sw)
  // set norms based on ALL adjacent faces - lots of verts means lots of time
  #local i=0;
  echo("\n")
  /*w#while (i<NumVertices)
    #declare N_vec_Arr[i]=y;
    #local i=i+1;
  #end  */
  #local i=0;
  #while (i<NumVertices)
    #local nrm = <0,0,0>;
    #local j = 0;
    #while (j<NumFaces)
      #if ((i = Face_Arr[j].x)|(i = Face_Arr[j].y)|(i = Face_Arr[j].z))
        #local norm = normal_vector(V_vec_Arr[Face_Arr[j].x],V_vec_Arr[Face_Arr[j].y],V_vec_Arr[Face_Arr[j].z]);
        #local nrm = vnormalize(nrm+vnormalize(norm));
      #end 
      #local j=j+1;
    #end // Faces
    #declare N_vec_Arr[i] = nrm;
    #local i=i+1;
    #if (sw)  // Progress
         #if ((mod(100*i/NumVertices,20) >= 0)&(mod(100*i/NumVertices,20)<0.05))
          #debug concat("Checking Normals  >  ",str(int(100*i/NumVertices),5,1),"%\n")
       #end
    #end
  #end // Verts
#end


#if (0)

#declare heart = prism {
linear_sweep
bezier_spline
1.0, //top
0.0, //bottom
24,
<0.100555,8.848856>,<2.718691,8.934339>,<5.832201,11.739637>,<8.594213,11.790276>,
<8.594213,11.790276>,<11.356222,11.840967>,<13.072265,10.030206>,<13.273284,7.114098>,
<13.273284,7.114098>,<13.77606,2.388004>,<8.14497,-6.963628>,<0.100555,-11.790277>,
<0.100555,-11.790277>,<-7.720738,-6.895353>,<-13.57495,2.388004>,<-13.273285,7.214653>,
<-13.273285,7.214653>,<-13.037419,9.818426>,<-11.446661,11.94138>,<-8.689705,11.790276>,
<-8.689705,11.790276>,<-5.932756,11.639081>,<-2.51388,8.848856>,<0.100555,8.848856>
}


#declare _heart = array[24] {
<0.030166,2.654657>,<0.815607,2.680302>,<1.74966,3.521891>,<2.578264,3.537083>,
<2.578264,3.537083>,<3.406867,3.55229>,<3.921679,3.009062>,<3.981985,2.134229>,
<3.981985,2.134229>,<4.132818,0.716401>,<2.443491,-2.089088>,<0.030166,-3.537083>,
<0.030166,-3.537083>,<-2.316221,-2.068606>,<-4.072485,0.716401>,<-3.981985,2.164396>,
<-3.981985,2.164396>,<-3.911226,2.945528>,<-3.433998,3.582414>,<-2.606911,3.537083>,
<-2.606911,3.537083>,<-1.779827,3.491724>,<-0.754164,2.654657>,<0.030166,2.654657>
}
                  
                  
                   
       ///////////////////// NEW SWEEPS \\\\\\\\\\\\\\\\\\\\\\
       sweep_pnts_array(0.24,0.001,bezier_length(_heart)/(90+1)+.0005,_heart,0) // bSpline  perimeter  bezier_length()/npnts
       #declare aSpline = array [1] { <0,0,0> } // 90 with one space
       
       #declare Vmin=0;#declare Vmax=pi;
       #declare Umin=0;#declare Umax=pi; 
       bezierPrism(4,1,1.5,4.5,0,8,0,1)

               #declare write_file = 10;  // else read file

                #if (write_file)
                          echo("\nChecking Normals...Estimated Time: ") echo(str(NumVertices*.03/420*60,0,2)) echo(" Mins.\n")
                          FastNorms77(0)
               
                          WriteMesh("heart_mesh5.pov")
                          WriteMesh1("heart_mesh15.pov","Surface_m1")
               #else #include "heart_mesh15.pov" #include "heart_mesh5.pov"
               #end
                      
               //#include "heart_mesh15.pov"
               union {
                 
                 #if (0)                                     
                   object { Triangles(0,<.9,.3,.4,.9,.1>) oldtex(<231/255,186/255,244/255,0,0>*2.5) }
                   object { Triangles(0,<.9,.3,.4,.9,.1>) oldtex(<231/255,186/255,244/255,0,0>*2.5) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
                 #else #if (write_file)
                   object { _Surface() oldtex(<231/255,186/255,244/255,0,0>*2.5) }
                   object { _Surface() oldtex(<244/255,176/255,203/255,0,0>*2.5) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
                 #else
                   object { Surface oldtex(<231/255,186/255,244/255,0,0>*2.5) }
                   object { Surface oldtex(<231/255,186/255,244/255,0,0>*2.5) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
                 #end  #end
                 rotate <-90,0,0> 
                 scale .3
                 translate y*3
                // translate x*2
              }
              #declare NORMALS = 0;
              object { _Surface() tex(<231/255,186/255,244/255,.5,.5>)
                 rotate <-80,-5,0> 
                 scale .42
                 translate <-4.1,0,.5>
               } 
               #declare NORMALS = 0;
               object {
                object { Surface tex(<2,0,0,.5,.5>) }
                //object { Surface_m1 tex(<1.5,0,0,.5,.5>) matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
                 rotate <-90,0,0> 
                 scale .25
                 translate <4,5,0>
               } 
               union { 
                 union { By_Edges(0.02) texture { T_Chrome_3C } }
                 union { By_Edges(0.02) texture { T_Chrome_3C } matrix <1,0,0,0,-1,0,0,0,1,0,0,0> }
                 rotate <-80,15,0> 
                 scale .25
                 translate <-4,5,-1>
               } 
              object { _Surface() tex(<231/255,186/255,244/255,.5,.5>)
                 rotate <-80,15,0> 
                 scale .42
                 translate <4,0,-1>
               }
#end
#if (0)
////////////////////P SWEEPS\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
// set bSpline[], an even pnt spread along multiple bezier paths
sweep_pnts_array(0.24,0.001,bezier_length(P_bez_noc)/(194+1)+.0000001,P_bez_noc,0)           // bSpline  perimeter
sweep_pnts_array(0.24,0.001,bezier_length(bakbone)/(86+1)+.0005,bakbone,1)         // aSpline  .585=86

#declare Vmin=PI_5;#declare Vmax=PI_5;
#declare Umin=0;#declare Umax=PI_5;

          #declare write_file = 0;  // else read file

       bezierPrism(1,1,1,1,0,14,0,1) //bezierPrism(4,1,1.5,.1,0,8,0,1)
       //WriteMesh("P_logotst.pov")
       #if (write_file)
           echo("\nChecking Normals...Estimated Time: ") echo(str(NumVertices*1.12 / 3900,0,2)) echo(" Hrs.\n")
           FastNorms77(1)
           WriteMesh1("P_mesh7.pov","P_mesh7")
           WriteMesh("P_logomesh7.pov")
       #else #include "P_logomesh7.pov" //#include "P_mesh7.pov"
       #end    
       
       union {
         object { //SmoothTriangles(<.4,.9,.4,0,0>)  
                //Spheroid_Surface oldtex(<.4,.9,.4,0,0>)
                #if (0) Triangles(0,<.9,.3,.4,.9,.1>)
                #else #if (write_file) _Surface()
                #else Surface
                #end #end
         }      
         object { 
                #if (0) Triangles(0,<.9,.3,.4,.9,.1>)
                #else #if (write_file) _Surface()
                #else Surface
                #end #end
                 matrix <1,0,0,0,-1,0,0,0,1,0,0,0>
         }
         //oldtex(<.4,.9,.4,0,0>)
         scale <1,4,1>
         oldtex(<.9,.1,1.5,0,0>)
         
         //oldtex(<231/255,186/255,244/255,0,0>*1.5)
         //tex(<.7,.1,.4,0,0>)

         rotate <-90,0,0> 
         scale .3
         translate y*3
        // translate x*-2.6
       }
#end 



#if (10)
    #declare ship_prim = array[28] {
    <-8.953947,.1>,<-8.891767,0.497442>,<-3.29555,3.482091>,<-1.927586,3.606451>,
    <-1.927586,3.606451>,<4.041712,3.606451>,<7.088541,6.404559>,<7.088541,7.896884>,
    <7.088541,7.896884>,<8.088541,7.896884>,<8.078307,7.896884>,<9.078307,7.896884>,
    //<9.078307,7.896884>,<9.074401,6.896892>,<9.020033,-1>,<9.016127,0>,
    <9.078307,7.896884>,<9.074401,6.896892>,<9.020033,-7.021252>,<9.016127,-8.021244>,
    <9.016127,-8.021244>,<8.016615,-8.052479>,<8.025873,-8.052189>,<7.026361,-8.083424>,
    <7.026361,-8.083424>,<7.026361,-6.46674>,<4.041712,-3.792991>,<-1.989766,-3.792991>,
    <-1.989766,-3.792991>,<-3.35773,-3.730811>,<-8.891767,-0.497442>,<-8.953947,-.1>
    }
    #declare ship_top = array[12] {
    <-8.47607,0.384869>,<-7.547593,0.75626>,<-3.207918,1.522314>,<-1.986998,2.980498>,
    <-1.986998,2.980498>,<0.373618,3.780239>,<5.823781,3.468801>,<6.961089,2.980498>,
    <6.961089,2.980498>,<7.925987,2.417698>,<7.510843,2.269051>,<8.122291,1.477766>
    }
    ////////////////////SHIP SWEEPS\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
    
    sweep_pnts_array(0.24,0.001,bezier_length(ship_prim)/(79+1)+.0005,ship_prim,0)   //xz bSpline  perimeter
    sweep_pnts_array_xy(0.24,0.001,bezier_length(ship_top)/(39+1)+.0005,ship_top,1)         // aSpline
    
    #declare Vmin=0;#declare Vmax=PI;
    #declare Umin=0;#declare Umax=PI;

       #declare write_file = 1;  // else read file

       bezierPrismQ(0,0,1.2,1,-90,14,0,1)  //extrudHeight,,,,,slices,sub-edges,close

       #if (write_file)
           echo("\nChecking Normals...Estimated Time: ") echo(str(NumVertices*1.12 / 3900,0,2)) echo(" Hrs.\n")
           FastNorms77(1)
           WriteMesh1("ship71.pov","ship71")
           WriteMesh("ship7.pov")
       #else #include "ship7.pov" //#include "ship71.pov"
       #end
       #macro ship(tri)
       union {
        object { 
                #if (tri) Triangles(0,<.9,.3,.4,.9,.1>)
                #else #if (write_file) _Surface()
                #else Surface
                #end #end
         }

         object { 
                #if (tri) Triangles(0,<.9,.3,.4,.9,.1>)
                #else #if (write_file) _Surface()
                #else Surface
                #end #end
                scale <1,.5,1>
               matrix <1,0,0,0,-1,0,0,0,1,0,0,0>
         }
//         bounded_by { sphere  { 0 12 } }
       }
       #end


       
    #declare window = 
     union {   
         triangle { <-2.49991,2.5201,0> <-2.88586,2.27327,0> <-2.60506,2.24331,0.425737>          }
         triangle { <-2.88586,2.27327,0> <-3.28668,2.05984,0> <-3.04225,2.03308,0.422317>         }
         triangle { <-2.60506,2.24331,0.425737> <-2.18143,2.48646,0.432751> <-2.49991,2.5201,0>    }
         triangle { <-3.04225,2.03308,0.422317> <-2.60506,2.24331,0.425737> <-2.88586,2.27327,0>   }
                                                                                                  
         triangle { <-2.18143,2.48646,0.432751> <-2.60506,2.24331,0.425737> <-2.37273,2.1424,0.777988>    }
         triangle { <-2.60506,2.24331,0.425737> <-3.04225,2.03308,0.422317> <-2.83826,1.94191,0.77477>  }
         triangle { <-2.37273,2.1424,0.777988> <-1.92018,2.3743,0.787742> <-2.18143,2.48646,0.432751>   }
         triangle { <-2.83826,1.94191,0.77477> <-2.37273,2.1424,0.777988> <-2.60506,2.24331,0.425737> }

        triangle { <-2.33658,2.14319,-0.827583> <-2.80182,1.94269,-0.823255> <-3.02348,2.03354,-0.446895>}
        
        triangle { <-2.16339,2.48693,-0.4584> <-1.88469,2.37509,-0.838035> <-2.33658,2.14319,-0.827583> }               // versus these
        triangle { <-2.16339,2.48693,-0.4584> <-2.33658,2.14319,-0.827583> <-2.58656,2.24378,-0.450946>  }              // versus these opposite diagonal
        
        triangle { <-2.58656,2.24378,-0.450946> <-3.02348,2.03354,-0.446895> <-2.33658,2.14319,-0.827583> }
        
        triangle { <-2.16339,2.48693,-0.4584> <-2.58656,2.24378,-0.450946> <-2.88586,2.27327,0> }
        triangle { <-2.58656,2.24378,-0.450946> <-3.02348,2.03354,-0.446895> <-3.28668,2.05984,0> }
        triangle { <-2.88586,2.27327,0> <-2.49991,2.5201,0> <-2.16339,2.48693,-0.4584> }
        triangle { <-3.28668,2.05984,0> <-2.88586,2.27327,0> <-2.58656,2.24378,-0.450946> }
        translate x*-.07
        tex(<0,0,.3,0,0>)
    }
       
    union {
        object { ship(0) texture { T_Chrome_3C } }
        object { window }
        rotate <0,-60,0> 
        scale .45
        translate y*2
        translate x*1
        translate z*-1
   }
   union {
        object { ship(1) oldtex(<.4,.9,.4,0,0>)  }
        object { window }
        rotate <0,-100,0> 
        scale .45
        translate y*2
        translate x*-2.6
        translate y*-2
        translate z*-4
}
#end        